	cpu 286
	org 100h

%define	b	byte
%define	w	word
%define	d	dword

start:
	cli
	call	Disable
	mov	si, 81h
@@skipsp:
	lodsb
	cmp	al,' '
	jz	@@skipsp
	and	al,0DFh
	cmp	al,'M'
	jnz	@@not_mt32
	mov	b [soundcard],4
@@not_mt32:

	mov	sp,ENDDRIVER+200h
	mov	bx,sp
	shr	bx,4
	inc	bx
	mov	ah,4Ah
	int	21h
	mov	bx,2000h
	mov	ah,48h
	int	21h
	mov	[ExeSeg],ax
	mov	[ExeSeg+2],ax
	add	ax,9Ah
	mov	[seg1],ax
	add	ax,44ch-9ah
	mov	[seg23],ax
	add	ax,594h-44ch
	mov	[seg44],ax
	add	ax,661h-594h
	mov	[dseg],ax

	mov	dx,ExeName
	mov	bx,ExeSeg
	mov	ax,4B03h
	int	21h			;load exe as an overlay
	jc	Crash

	cli
	mov	ax,[dseg]
	mov	ds,ax
	mov	ss,ax
	mov	sp,0FFF0h

	mov	es,[cs:seg23]	;replace farmalloc and farfree with primitive versions
	mov	di,203h		;that do not require initializing c runtime
	mov	al,0EAh
	stosb
	mov	ax,farmalloc
	stosw
	mov	ax,cs
	stosw
	mov	es,[cs:seg44]
	mov	di,02cah
	mov	al,0eah
	stosb
	mov	ax,farfree
	stosw
	mov	ax,cs
	stosw

	xor	cx,cx
	mov	ax,[cs:soundcard]	;sound type: 1 = opn, 4 = mt32
	mov	[1ddfh],al
	mov	bp,1a15h
	call	DRIVER			;load and init driver

	push	cs
	pop	ds
	mov	dx,NewInt7F
	mov	ax,257Fh
	int	21h
	call	Enable
	sti
@@infyloop:
	mov	ax,9801h
	int	18h
	jmp	@@infyloop
Disable:
	mov	al,80h
	jmp	HootOut
Enable:
	mov	al,81h
HootOut:
	mov	dx,7E8h
	out	dx,al
	ret
Crash:
	cli
	mov	bx,0DEADh
	mov	cx,bx
	mov	dx,bx
@@loop1:
	jmp	@@loop1
;
NewInt7F:
	cli
	cld
	pusha
	push	ds
	push	es
	call	Disable
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	dx,7E0h
	in	al,dx
	test	al,al
	jz	@@play
	cmp	al,2
	jnz	@@exitint
	call	@@stop
@@exitint:
	call	Enable
	pop	es
	pop	ds
	popa
	iret
@@play:
	call	@@stop
	mov	dx,7E2h
	in	ax,dx
	mov	bp,1c39h
	call	DRIVER
	jmp	@@exitint
@@stop:
	xor	ax,ax
	mov	bp,1c39h
DRIVER:
	push	cx
	push	ax
	mov	[cs:seg1call],bp
	mov	ds,[cs:dseg]
	call	far [cs:seg1call]
	pop	cx
	pop	cx
	ret

farmalloc:
	push	bp
	mov	bp,sp
	push	bx
	mov	bx,[bp+6]
	shr	bx,4
	inc	bx
	mov	ah,48h
	int	21h
	jc	@@bad 
	mov	dx,ax
	xor	ax,ax
	jmp	@@bye
@@bad:
	xor	ax,ax
	xor	dx,dx
@@bye:
	pop	bx
	leave
	retf
;
farfree:
	push	bp
	mov	bp,sp
	push	es
	mov	es,[bp+8]
	mov	ah,49h
	int	21h
	pop	es
	leave
	retf

ExeName	db 'END.EXE',0
	align 2
soundcard	dw 1
seg1call	dw 0
seg1		dw 0
seg23	dw 0
seg44	dw 0
dseg		dw 0
ExeSeg	dw 0,0,0
	db	13,10,13,10,"Ultima VI PC98 Driver v1.0 by Mok"
ENDDRIVER:
	end
